#ifndef __CLASS_SPRITE__
#define __CLASS_SPRITE__

#include <vector>
#include <string>
#include <SDL/SDL.h>
#include "frame.h"

using namespace std;

//accediamo alla screen globale
extern SDL_Surface *screen;
//accediamo alla bg globale
extern SDL_Surface *bg;

class sprite
{
	//cordinate dell'img (x,y)
	int x, y; 
	//velocit di spostamento dell'animazione
	int s_speed;
	//indice del frame corrente
	int cur_frame;
	//flag che indica se ci stiamo muovendo
	bool moving;
	//ultimo tempo di aggiornamento del frame
	long update_time;
	//idealmente uno sprite  un insieme di frame 
	vector<frame *> frames;
public:
	//costruttore
	sprite(vector <string> files, int init_x=0, int init_y=0, int speed=2);	
	//distruttore
	~sprite();

	//function di spostamento frame
	void mov_x(int mov=1); 
	void mov_y(int mov=1); 


	//function che ritornano le cordinate posizionali del frame
	int get_x() { return x; };
	int get_y() { return y; };
	
	//function che ritornano le dimensioni di un frame
	int get_w(int ind=0) { return frames[ind]->get_w();}
	int get_h(int ind=0) { return frames[ind]->get_h();}

	//function principale, che gestisce il disegno e l'animazione dello sprite
	void draw_sprite();
	//function che ridisegna il background modificato dallo sprite
	void draw_bg();

};

#endif
